//
//  SourceEditorCommand.swift
//  NSCoconut
//
//  Created by Sebastian Dobrincu on 10/07/16.
//  Copyright © 2016 Sebastian Dobrincu. All rights reserved.
//

import Foundation
import XcodeKit

class SourceEditorCommand: NSObject, XCSourceEditorCommand {
    
    func perform(with invocation: XCSourceEditorCommandInvocation, completionHandler: (NSError?) -> Void ) -> Void {
        // Implement your command here, invoking the completion handler when done. Pass it nil on success, and an NSError on failure.
        
        print("Content Type: \(invocation.buffer.contentUTI)")
        print("Command Identifier: \(invocation.commandIdentifier)")
        
        if invocation.commandIdentifier.contains("CoolHeader") {
            
            var reachedEndOfHeaderSection = false
            var lastCommentLine = 0
            let newHeader = "//\n//    _   _   ____     ____                                          _\n//   | \\ | | / ___|   / ___|   ___     ___    ___    _ __    _   _  | |_\n//   |  \\| | \\___ \\  | |      / _ \\   / __|  / _ \\  | __ \\  | | | | | __|\n//   | |\\  |  ___) | | |___  | (_) | | (__  | (_) | | | | | | |_| | | |_\n//   |_| \\_| |____/   \\____|  \\___/   \\___|  \\___/  |_| |_|  \\____|  \\__|\n//                                                                       "
            
            while !reachedEndOfHeaderSection {
                let currentLine = invocation.buffer.lines[lastCommentLine] as! String
                
                if currentLine.hasPrefix("//") {
                    invocation.buffer.lines[lastCommentLine] = ""
                    lastCommentLine += 1
                }else {
                    reachedEndOfHeaderSection = true
                    lastCommentLine -= 1
                }
            }
            
            invocation.buffer.lines[0] = newHeader
        }
        
        completionHandler(nil)
    }
    
}
